require "spec_helper"

RSpec.describe TextEditor::Command::CursorEnd do
  include CommandHelper

  describe "#run" do
    context "with an empty buffer" do
      before do
        expect_buffer("")
        expect_cursor(0, 0)
      end

      it "does not move cursor" do
        subject.run
        expect_buffer("")
        expect_cursor(0, 0)
      end
    end

    context "with an non-empty buffer" do
      before { update_buffer("ab cd") }

      it "moves cursor one column past the end of the line" do
        subject.run
        expect_buffer("ab cd")
        expect_cursor(0, 5)
      end
    end
  end
end
