require "spec_helper"

RSpec.describe TextEditor::Command::CursorLeftWithWrap do
  include CommandHelper

  describe "#run" do
    context "with an empty buffer" do
      before do
        expect_buffer("")
        expect_cursor(0, 0)
      end

      it "does not move cursor" do
        subject.run
        expect_buffer("")
        expect_cursor(0, 0)
      end
    end

    context "with an non-empty buffer" do
      before do
        update_buffer("ab")
        update_cursor(0, 1)
      end

      it "moves cursor to the left" do
        subject.run
        expect_buffer("ab")
        expect_cursor(0, 0)
      end
    end

    context "with a buffer containing multiple lines" do
      before do
        update_buffer("ab\ncd")
        update_cursor(1, 0)
      end

      it "wraps to previous line" do
        subject.run
        expect_buffer("ab\ncd")
        expect_cursor(0, 2)
      end
    end
  end
end
