require "spec_helper"

RSpec.describe TextEditor::Command::InsertLine do
  include CommandHelper

  describe "#run" do
    before do
      expect_buffer("")
      expect_cursor(0, 0)
    end

    it "adds newline and moves cursor" do
      subject.run
      expect_buffer("\n")
      expect_cursor(1, 0)
    end

    it "adds newline in the middle of string" do
      update_buffer("test")
      update_cursor(0, 2)
      subject.run
      expect_buffer("te\nst")
      expect_cursor(1, 0)
    end
  end
end
