require "spec_helper"

RSpec.describe TextEditor::Command::ReplaceLine do
  include CommandHelper

  describe "#run" do
    context "with an empty buffer" do
      before do
        expect_buffer("")
        expect_cursor(0, 0)
      end

      it "does not move cursor" do
        subject.run
        expect_buffer("")
        expect_cursor(0, 0)
      end
    end

    context "with a one line buffer" do
      before do
        update_buffer("ab")
        update_cursor(0, 1)
      end

      it "clears line and changes to insert mode at start of line" do
        subject.run
        expect_buffer("")
        expect_cursor(0, 0)
        expect_mode(:insert)
      end
    end
  end
end
