require "spec_helper"

RSpec.describe TextEditor::Configuration do
  subject { described_class.new(editor) }

  let(:editor) { double("editor") }

  describe "#files" do
    it "is an accessor" do
      expect(subject.files).to be_nil

      subject.files = "test"
      expect(subject.files).to eq("test")
    end
  end

  describe "#log" do
    let(:log) { described_class::Log }

    it "returns a Log instance" do
      expect(subject.log).to be_a(log)
    end
  end

  describe "#tag" do
    let(:tab) { described_class::Tab }

    it "returns a Tab instance" do
      expect(subject.tab).to be_a(tab)
    end
  end
end
