require "spec_helper"

RSpec.describe TextEditor::Reactor do
  subject { described_class.new(editor) }

  let(:editor) { double("editor") }

  describe "#start" do
    it "starts running" do
      expect(subject).to receive(:render)
      expect(subject).to receive(:listen)

      expect(subject).not_to be_running
      subject.start
      expect(subject).to be_running
    end
  end

  describe "#stop" do
    it "stops running" do
      subject.instance_variable_set("@running", true)
      expect(subject).to be_running

      subject.stop
      expect(subject).not_to be_running
    end
  end

  describe "#running?" do
    it "is not running by default" do
      expect(subject).not_to be_running
    end
  end
end
